L3BUILD(1)

NAME
l3build

SYNOPSIS
 Usage l3build <target> [<options>] [<names>]

DESCRIPTION

The "l3build" module is designed to support the development of high-quality LaTeX code by providing:

 * A unit testing system

 * Automated typesetting of code sources

 * A reliable packaging system for CTAN releases

The bundle consists of a Lua script to run the tasks and a ".tex" file which provides the testing environment. These were originally developed for supporting LaTeX development but are designed such that they can be readily used by others. Full documentation is provided.

COMMANDS
Valid targets are:
   check Runs all automated tests
   clean Cleans out directory tree
   ctan Creates CTAN-ready archive
   doc Typesets all documentation files
   install Installs files into the local texmf tree
   manifest Creates a manifest file
   save Saves test validation log
   tag Updates release tags in files
   uninstall Uninstalls files from the local texmf tree
   unpack Unpacks the source files into the build tree
   upload Sends archive to CTAN for public release

OPTIONS
Valid options are:
   --config|-c Sets the config(s) used for running tests
   --date|-d Sets the date to insert into sources
   --debug Runs target in debug mode
   --dev Use the development LaTeX format
   --dirty Skips cleaning up the test area
   --dry-run Dry run for install or upload
   --email Email address of CTAN uploader
   --engine|-e Sets the engine(s) to use for running test
   --epoch Sets the epoch for tests and typesetting
   --file|-F Takes the upload announcement from the given file
   --first Name of first test to run
   --full Installs all files
   --halt-on-error|-H Stops running tests after the first failure
   --help|-h Prints this message and exits
   --last Name of last test to run
   --message|-m Text for upload announcement message
   --quiet|-q Suppresses TeX output when unpacking
   --rerun Skips setup: simply reruns tests
   --show-log-on-error Shows the full log of the failure with 'halt-on-error'
   --show-saves|-S Shows the invocation to update failing .tlg files
   --shuffle Shuffles order of tests
   --stdengine|-s Run tests with the std engine (config dependent)
   --texmfhome Location of user texmf tree
   --version Prints version information and exits

SEE ALSO
Full manual available via 'texdoc l3build'.

Repository : https://github.com/latex3/l3build

Bug tracker : https://github.com/latex3/l3build/issues

AUTHORS
Copyright (C) 2014-2025 The LaTeX Project